import { useDeep, useDeepId } from '@deep-foundation/deeplinks/imports/client';
import json5 from 'json5';
import { useRef } from 'react';
import { useCytoHandlersSwitch, useInsertingCytoStore, useShowFocus, useShowOpened, useShowTypes } from '../hooks';
import { useCytoHandlersRules } from './hooks';
export function useCytoElements(ml, _links, cy, spaceId, cyh) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50, _51, _52, _53, _54, _55, _56, _57, _58, _59, _60, _61, _62;
    const [showTypes, setShowTypes] = useShowTypes();
    const [showFocus, setShowFocus] = useShowFocus();
    const [showOpened, setShowOpened] = useShowOpened();
    const [cytoHandlers, setCytoHandlers] = useCytoHandlersSwitch();
    const [chr, setChr] = useCytoHandlersRules();
    const [insertingCyto, setInsertingCyto] = useInsertingCytoStore();
    const oldElements = useRef([]);
    const deep = useDeep();
    const { data: HandleCyto } = useDeepId('@deep-foundation/handle-cyto', 'HandleCyto');
    const { data: Opened } = useDeepId('@deep-foundation/deepcase-opened', 'Opened');
    const { data: OpenedHandler } = useDeepId('@deep-foundation/deepcase-opened', 'OpenedHandler');
    const links = _links;
    const elementsById = {};
    const cytoHandled = {};
    let elements = [];
    const reactElements = [];
    for (let i = 0; i < links.length; i++) {
        const link = links[i];
        const cyHandle = (_b = (_a = deep.minilinks) === null || _a === void 0 ? void 0 : _a.byType[HandleCyto]) === null || _b === void 0 ? void 0 : _b.find(l => l.from_id === link.type_id);
        if (cyh.drawedCytoHandlers.current[link.id] && (!cytoHandlers || !chr[cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.id])) {
            continue;
        }
        if (cytoHandlers && cyHandle && !!chr[cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.id]) {
            cytoHandled[link.id] = cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.to_id;
            continue;
        }
        const focus = (_d = (_c = link === null || link === void 0 ? void 0 : link.inByType) === null || _c === void 0 ? void 0 : _c[deep.idLocal('@deep-foundation/core', 'Focus')]) === null || _d === void 0 ? void 0 : _d.find(f => f.from_id === spaceId);
        const isFocusSpace = ((link.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && (link === null || link === void 0 ? void 0 : link.from_id) === spaceId && link._applies.includes('space'))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_e = link === null || link === void 0 ? void 0 : link.to) === null || _e === void 0 ? void 0 : _e.type_id) === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space')));
        const isOpenedSpace = ((link.type_id === Opened && link._applies.includes('space') && (link === null || link === void 0 ? void 0 : link.from_id) === spaceId)
            ||
                (link.type_id === OpenedHandler && link._applies.includes('space')
                    &&
                        (((_f = link === null || link === void 0 ? void 0 : link.from) === null || _f === void 0 ? void 0 : _f.type_id) === Opened && ((_g = link === null || link === void 0 ? void 0 : link.from) === null || _g === void 0 ? void 0 : _g.from_id) === spaceId && link._applies.includes('space')))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_h = link === null || link === void 0 ? void 0 : link.to) === null || _h === void 0 ? void 0 : _h.from_id) === spaceId && ((_j = link === null || link === void 0 ? void 0 : link.to) === null || _j === void 0 ? void 0 : _j.type_id) === Opened && link._applies.includes('space'))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_k = link === null || link === void 0 ? void 0 : link.to) === null || _k === void 0 ? void 0 : _k.type_id) === OpenedHandler && ((_m = (_l = link === null || link === void 0 ? void 0 : link.to) === null || _l === void 0 ? void 0 : _l.from) === null || _m === void 0 ? void 0 : _m.from_id) === spaceId && ((_p = (_o = link === null || link === void 0 ? void 0 : link.to) === null || _o === void 0 ? void 0 : _o.from) === null || _p === void 0 ? void 0 : _p.type_id) === Opened && link._applies.includes('space')));
        let _value = '';
        let _name = '';
        let _type = '';
        let _symbol = '';
        if (typeof ((_q = link === null || link === void 0 ? void 0 : link.value) === null || _q === void 0 ? void 0 : _q.value) !== 'undefined') {
            let json;
            try {
                json = json5.stringify(link === null || link === void 0 ? void 0 : link.value.value);
            }
            catch (error) { }
            _value = (typeof (link === null || link === void 0 ? void 0 : link.value.value) === 'object' && json
                ? json : link === null || link === void 0 ? void 0 : link.value.value);
            if (typeof (_value) === 'string')
                _value = _value.split('\n')[0];
            if (_value.length > 20)
                _value = _value.slice(0, 11) + '...' + _value.slice(-9, _value.length);
        }
        if ((_u = (_t = (_s = (_r = link === null || link === void 0 ? void 0 : link.inByType) === null || _r === void 0 ? void 0 : _r[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _s === void 0 ? void 0 : _s[0]) === null || _t === void 0 ? void 0 : _t.value) === null || _u === void 0 ? void 0 : _u.value) {
            _name = `name:${(_y = (_x = (_w = (_v = link === null || link === void 0 ? void 0 : link.inByType) === null || _v === void 0 ? void 0 : _v[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _w === void 0 ? void 0 : _w[0]) === null || _x === void 0 ? void 0 : _x.value) === null || _y === void 0 ? void 0 : _y.value}`;
        }
        if ((_1 = (_0 = (_z = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _z === void 0 ? void 0 : _z.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _0 === void 0 ? void 0 : _0.value) === null || _1 === void 0 ? void 0 : _1.value) {
            _type = `type:${(_4 = (_3 = (_2 = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _2 === void 0 ? void 0 : _2.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _3 === void 0 ? void 0 : _3.value) === null || _4 === void 0 ? void 0 : _4.value}`;
        }
        if ((_7 = (_6 = (_5 = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _5 === void 0 ? void 0 : _5.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _6 === void 0 ? void 0 : _6.value) === null || _7 === void 0 ? void 0 : _7.value) {
            _symbol = (_10 = (_9 = (_8 = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _8 === void 0 ? void 0 : _8.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _9 === void 0 ? void 0 : _9.value) === null || _10 === void 0 ? void 0 : _10.value;
        }
        function isValidValue(value) {
            return value !== null && typeof value !== 'undefined' && !Number.isNaN(value) && value !== '';
        }
        const has_focus = !!((_12 = (_11 = focus === null || focus === void 0 ? void 0 : focus.value) === null || _11 === void 0 ? void 0 : _11.value) === null || _12 === void 0 ? void 0 : _12.x);
        const existed = !!oldElements.current.find((oldLink) => oldLink.id === link.id);
        const element = Object.assign(Object.assign({ id: link.id, data: {
                id: `${link.id}`,
                label: (`${link.id}`
                    + (_type ? '\n' + `${_type}` : '')
                    + (_name ? '\n' + `${_name}` : '')
                    + (isValidValue(_value) ? '\n' + `${_value}` : '')
                    + `\n\n ${_symbol || '📍'}`),
                link,
            }, selectable: false, classes: [
                'link-node',
                ...(focus ? ['focused'] : ['unfocused']),
            ].join(' ') }, (has_focus ? {
            position: !existed ? (_13 = focus === null || focus === void 0 ? void 0 : focus.value) === null || _13 === void 0 ? void 0 : _13.value : {},
        } : {})), { focused: !!focus });
        if (((isFocusSpace && showFocus) || !isFocusSpace) && ((isOpenedSpace && showOpened) || !isOpenedSpace)) {
            elementsById[link === null || link === void 0 ? void 0 : link.id] = element;
            elements.push(element);
        }
    }
    for (let i = 0; i < links.length; i++) {
        const link = links[i];
        if (cytoHandled[link === null || link === void 0 ? void 0 : link.id])
            continue;
        if (cyh.drawedCytoHandlers.current[link.id] && !cytoHandlers) {
            continue;
        }
        const focus = (_15 = (_14 = link === null || link === void 0 ? void 0 : link.inByType) === null || _14 === void 0 ? void 0 : _14[deep.idLocal('@deep-foundation/core', 'Focus')]) === null || _15 === void 0 ? void 0 : _15.find(f => f.from_id === spaceId);
        const isFocusSpace = ((link.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && (link === null || link === void 0 ? void 0 : link.from_id) === spaceId && link._applies.includes('space'))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_16 = link === null || link === void 0 ? void 0 : link.to) === null || _16 === void 0 ? void 0 : _16.type_id) === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space')));
        const isOpenedSpace = ((link.type_id === Opened && link._applies.includes('space') && (link === null || link === void 0 ? void 0 : link.from_id) === spaceId)
            ||
                (link.type_id === OpenedHandler && link._applies.includes('space')
                    &&
                        (((_17 = link === null || link === void 0 ? void 0 : link.from) === null || _17 === void 0 ? void 0 : _17.type_id) === Opened && ((_18 = link === null || link === void 0 ? void 0 : link.from) === null || _18 === void 0 ? void 0 : _18.from_id) === spaceId && link._applies.includes('space')))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_19 = link === null || link === void 0 ? void 0 : link.to) === null || _19 === void 0 ? void 0 : _19.from_id) === spaceId && ((_20 = link === null || link === void 0 ? void 0 : link.to) === null || _20 === void 0 ? void 0 : _20.type_id) === Opened && link._applies.includes('space'))
            ||
                ((link === null || link === void 0 ? void 0 : link.type_id) === deep.idLocal('@deep-foundation/core', 'Contain') && ((_21 = link === null || link === void 0 ? void 0 : link.to) === null || _21 === void 0 ? void 0 : _21.type_id) === OpenedHandler && ((_23 = (_22 = link === null || link === void 0 ? void 0 : link.to) === null || _22 === void 0 ? void 0 : _22.from) === null || _23 === void 0 ? void 0 : _23.from_id) === spaceId && ((_25 = (_24 = link === null || link === void 0 ? void 0 : link.to) === null || _24 === void 0 ? void 0 : _24.from) === null || _25 === void 0 ? void 0 : _25.type_id) === Opened && link._applies.includes('space')));
        let _value = '';
        let _name = '';
        let _type = '';
        let _symbol = '';
        if ((_26 = link === null || link === void 0 ? void 0 : link.value) === null || _26 === void 0 ? void 0 : _26.value) {
            let json;
            try {
                json = json5.stringify(link === null || link === void 0 ? void 0 : link.value.value);
            }
            catch (error) { }
            _value = (typeof (link === null || link === void 0 ? void 0 : link.value.value) === 'object' && json
                ? json : link === null || link === void 0 ? void 0 : link.value.value);
        }
        if ((_30 = (_29 = (_28 = (_27 = link === null || link === void 0 ? void 0 : link.inByType) === null || _27 === void 0 ? void 0 : _27[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _28 === void 0 ? void 0 : _28[0]) === null || _29 === void 0 ? void 0 : _29.value) === null || _30 === void 0 ? void 0 : _30.value) {
            _name = `name:${(_34 = (_33 = (_32 = (_31 = link === null || link === void 0 ? void 0 : link.inByType) === null || _31 === void 0 ? void 0 : _31[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _32 === void 0 ? void 0 : _32[0]) === null || _33 === void 0 ? void 0 : _33.value) === null || _34 === void 0 ? void 0 : _34.value}`;
        }
        if ((_39 = (_38 = (_37 = (_36 = (_35 = link === null || link === void 0 ? void 0 : link.type) === null || _35 === void 0 ? void 0 : _35.inByType) === null || _36 === void 0 ? void 0 : _36[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _37 === void 0 ? void 0 : _37[0]) === null || _38 === void 0 ? void 0 : _38.value) === null || _39 === void 0 ? void 0 : _39.value) {
            _type = `type:${(_44 = (_43 = (_42 = (_41 = (_40 = link === null || link === void 0 ? void 0 : link.type) === null || _40 === void 0 ? void 0 : _40.inByType) === null || _41 === void 0 ? void 0 : _41[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _42 === void 0 ? void 0 : _42[0]) === null || _43 === void 0 ? void 0 : _43.value) === null || _44 === void 0 ? void 0 : _44.value}`;
        }
        _symbol = ((_49 = (_48 = (_47 = (_46 = (_45 = link === null || link === void 0 ? void 0 : link.type) === null || _45 === void 0 ? void 0 : _45.inByType) === null || _46 === void 0 ? void 0 : _46[deep.idLocal('@deep-foundation/core', 'Symbol')]) === null || _47 === void 0 ? void 0 : _47[0]) === null || _48 === void 0 ? void 0 : _48.value) === null || _49 === void 0 ? void 0 : _49.value) || _symbol;
        if (!!cy && (!cyh.drawedCytoHandlers.current[link.id] || !cytoHandlers)) {
            if (((isFocusSpace && showFocus) || !isFocusSpace) && ((isOpenedSpace && showOpened) || !isOpenedSpace)) {
                if (link.from_id) {
                    if (((_50 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _50 === void 0 ? void 0 : _50[link.from_id]) && elementsById[link.from_id]) {
                        elements.push({
                            data: { id: `${link.id}-from`, source: `${link.id}`, target: `${link.from_id}`, link },
                            selectable: false,
                            classes: [
                                'link-from',
                                ...(focus ? ['focused'] : ['unfocused'])
                            ].join(' '),
                        });
                    }
                }
                if (link.to_id) {
                    if (((_51 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _51 === void 0 ? void 0 : _51[link.to_id]) && elementsById[link.to_id]) {
                        elements.push({
                            data: { id: `${link.id}-to`, source: `${link.id}`, target: `${link.to_id}`, link },
                            selectable: false,
                            classes: [
                                'link-to',
                                ...(focus ? ['focused'] : ['unfocused'])
                            ].join(' '),
                        });
                    }
                }
                if (showTypes) {
                    if (link.type_id) {
                        if (((_52 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _52 === void 0 ? void 0 : _52[link.type_id]) && elementsById[link.type_id]) {
                            elements.push({
                                data: { id: `${link.id}-type`, source: `${link.id}`, target: `${link.type_id}`, link },
                                selectable: false,
                                classes: [
                                    'link-type',
                                    ...(focus ? ['focused'] : ['unfocused'])
                                ].join(' '),
                            });
                        }
                    }
                }
            }
        }
    }
    for (let i = 0; i < elements.length; i++) {
        const el = elements[i];
        if (((_53 = el === null || el === void 0 ? void 0 : el.data) === null || _53 === void 0 ? void 0 : _53.source) && !elementsById[(_54 = el === null || el === void 0 ? void 0 : el.data) === null || _54 === void 0 ? void 0 : _54.source] && !cytoHandled[(_55 = el === null || el === void 0 ? void 0 : el.data) === null || _55 === void 0 ? void 0 : _55.source] && !cyh.drawedCytoHandlers.current[(_56 = el === null || el === void 0 ? void 0 : el.data) === null || _56 === void 0 ? void 0 : _56.source]) {
            const id = (_57 = el === null || el === void 0 ? void 0 : el.data) === null || _57 === void 0 ? void 0 : _57.source;
            const element = {
                id: id,
                data: {
                    id: `${id}`,
                    label: (`${id}\n\n `),
                    reasonEl: el,
                },
                selectable: false,
                classes: [
                    'link-node',
                ].join(' '),
            };
            elementsById[id] = element;
            elements.push(element);
        }
        if (((_58 = el === null || el === void 0 ? void 0 : el.data) === null || _58 === void 0 ? void 0 : _58.target) && !elementsById[(_59 = el === null || el === void 0 ? void 0 : el.data) === null || _59 === void 0 ? void 0 : _59.target] && !cytoHandled[(_60 = el === null || el === void 0 ? void 0 : el.data) === null || _60 === void 0 ? void 0 : _60.target] && !cyh.drawedCytoHandlers.current[(_61 = el === null || el === void 0 ? void 0 : el.data) === null || _61 === void 0 ? void 0 : _61.target]) {
            const id = (_62 = el === null || el === void 0 ? void 0 : el.data) === null || _62 === void 0 ? void 0 : _62.target;
            const element = {
                id: id,
                data: {
                    id: `${id}`,
                    label: (`${id}\n\n `),
                    reasonEl: el,
                },
                selectable: false,
                classes: [
                    'link-node',
                ].join(' '),
            };
            elementsById[id] = element;
            elements.push(element);
        }
    }
    oldElements.current = elements;
    return {
        elementsById, elements, reactElements, cytoHandled,
    };
}
//# sourceMappingURL=elements.js.map