var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useMemo } from 'react';
import { Input, HStack, Button, useColorMode, ButtonGroup, FormControl, FormLabel, Switch, InputGroup, InputRightElement, IconButton } from '@chakra-ui/react';
import { FinderPopover } from '../cyto/hooks';
import { useSpaceId } from '../hooks';
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
export const EditorSwitcher = React.memo(({ area, setArea, rightArea, fillSize, setFillSize, currentLinkId, setCurrentLinkId, portalRef, }) => {
    const deep = useDeep();
    const { colorMode } = useColorMode();
    const PortalProps = useMemo(() => ({
        containerRef: portalRef,
    }), []);
    const [space] = useSpaceId();
    const [spaceL] = deep.useMinilinksSubscription({ id: space });
    return (_jsxs(HStack, { spacing: 4, width: '100%', justifyContent: 'flex-end', px: 4, py: 2, borderTopStyle: 'solid', borderTopWidth: 1, borderTopColor: 'borderColor', children: [area == 'preview' && _jsx(_Fragment, { children: _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { htmlFor: 'input-id', mb: '0', children: "id" }), _jsxs(InputGroup, { mr: '1rem', children: [_jsx(Input, { id: "input-id", value: currentLinkId, size: 'sm', onChange: (e) => setCurrentLinkId(parseInt(e.target.value) || 0) }), _jsx(InputRightElement, { children: _jsx(FinderPopover, { PortalProps: PortalProps, link: spaceL, onSubmit: (link) => __awaiter(void 0, void 0, void 0, function* () {
                                            setCurrentLinkId(link === null || link === void 0 ? void 0 : link.id);
                                        }), children: _jsx(IconButton, { isRound: true, "aria-label": 'finder', size: 'sm', variant: 'ghost', icon: _jsx(_Fragment, { children: "\uD83E\uDEAC" }), style: {
                                                position: 'relative',
                                                top: -4,
                                            } }) }) })] }), _jsx(FormLabel, { htmlFor: 'show-extra-switch', mb: '0', children: "fillSize" }), _jsx(Switch, { id: 'show-extra-switch', isChecked: fillSize, onChange: () => setFillSize(!fillSize) })] }) }), _jsxs(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', children: [_jsx(Button, { "aria-label": 'Preview area', value: 'preview', isDisabled: area == 'preview', onClick: () => setArea('preview'), children: "Preview" }), _jsx(Button, { "aria-label": 'Handlers area', value: 'handlers', isDisabled: area == 'handlers', onClick: () => setArea('handlers'), children: "Handlers" }), _jsx(Button, { "aria-label": 'Results area', value: 'results', isDisabled: area == 'results', onClick: () => setArea('results'), children: "Results" })] })] }));
});
//# sourceMappingURL=editor-switcher.js.map